/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */


diaryControllers.controller('DiaryCtrl', function ($scope, $log, Configuration, $state, $uibModal, DiaryService, $filter,
        RequestStatusDefinitions, RunScheduleReportService,StyleRouting,$q, DiaryFactory, ClientConfigDefinitions, ViewReportService,RequestTypeDefinitions, ActionFactory, ActionDefinitions,
        ClientConfig, ConfirmModalService,uiGridConstants) {

    $scope.diaryUrl = ClientConfig.route('templates/diary/diary.html');
    $scope.configuration = Configuration.getConfiguration();
    
    //$scope.stylesheet = "gkhire";
    
    $scope.style = {};
    //$scope.style.stylesheet = ClientConfig.requestStyle( RequestTypeDefinitions.get().DELIVERY.id );
    $scope.buttonBackground = ClientConfig.requestStyle( RequestTypeDefinitions.get().DELIVERY.id );
    
    
    
    $scope.goToActions = function (){
        console.log("going to actions");
      $state.go('base.actionsscreen');  
    };
    
    $scope.goToWarehouse = function (){
        console.log("going to warehouse");
      $state.go('base.warehousescreen');  
    };
            
            
    $scope.sendToWarehouse = function( item ){
        
        // First Create Request Status Change Action ( In Warehouse ) this will update the status on the request to In Warehouse.
        var requestStatus = $scope.requestStatus().INWAREHOUSE;
        var requestStatusChangeAction = ActionFactory.buildNewCompletedAction({actionType: {id: requestStatus.actionId},
                            actionPriority: {id: ActionDefinitions.get().priority.high}, actorPersonId: item.employee,
                            acteePersonId: item.contact, createdByPersonId: item.employee, requestId: item.requestId, comment: "Sent To Warehouse"});
                        DiaryService.createAction(requestStatusChangeAction).then(function (data) {
                            
                            // Next Create AssignEquipment Action for this request
                            
                            var assignEquipmentAction = ActionFactory.buildNewPendingAction({actionType: {id: ActionDefinitions.get().type.assignequipment},
                            actionPriority: {id: ActionDefinitions.get().priority.high}, actorPersonId: item.employee,
                            acteePersonId: item.contact, createdByPersonId: item.employee, requestId: item.requestId, comment: item.equipementDetails});
                            
                            DiaryService.createAction(assignEquipmentAction).then(function (data2) {
                                $scope.load();
                            });
                            console.log("$scope.selectedRequest = ");
                            console.log($scope.selectedRequest);
                        });
                 
    };
            
    $scope.checkboxes = {
        showComplete: false,
        showDateFilter: false
    };

    //$scope.showComplete = false;
    //$scope.showDateFilter = true;

    $scope.requestStatus = function () {
        return RequestStatusDefinitions.get();
    };
    
    DiaryService.getEmployees().then(function (employees) {
        $scope.employees = employees.data;
    });

    //$scope.testData =  [ {id: 1, description: "David"}, {id: 2, description: "Jhon"}, {id: 3, description: "Danny"}];
    $scope.typesettings = {displayProp: 'description'};
    //Getting the request types and adding them to the filter dropdown
    DiaryService.getRequestTypes().then(function (types) {
        $scope.requestTypes = types.data;
        console.log("the request types are");
        console.log($scope.requestTypes);
        
        
        $scope.filterSelected.requestTypes = angular.copy($scope.requestTypes);
        $scope.filterSelected.requestTypes.push($scope.filterSelected.requestType);
    });
    
    


    $scope.showCompleteChecked = function () {
        console.log("Showing Complete");
        console.log($scope.checkboxes.showComplete);
    }


    $scope.filterSelected = {};
    $scope.filterSelected.employee = undefined;
    $scope.filterSelected.requestType = {id: 0, description: 'All'};
    $scope.filterSelected.fromDate = new Date();
    $scope.filterSelected.toDate = new Date();
    $scope.filterSelected.assigned = false;
    //$scope.filterSelected.showComplete = false;

    $scope.currentRequestType = {id: 0, description: 'All'};
    $scope.loadingRequestSpinner = "";


    $scope.fromDate = new Date();
    $scope.toDate = new Date();
    $scope.driverId = null;

    $scope.businessEntities = DiaryService.getCustomers();
    $scope.actionTypes = DiaryService.getActionTypes();
//    DiaryService.getRequests().then(function (requests) {
//        $scope.requests = requests.data;
//        //$scope.requests[0].actions = $scope.myTestTasks;
//        console.log("the request is");
//        console.log($scope.requests);
//
//        $scope.requestGridOptions.data = $scope.requests;
//
//
//
//
//    });

    $scope.load = function () {
        
        var getPromise = $q.defer();

        console.log("loading the requests");
        
        console.log($scope.filterSelected.employee);
        
        $scope.loadingRequestSpinner = "glyphicon glyphicon-refresh spinning";
        if ($scope.filterSelected.employee !== undefined) {
            $scope.driverId = $scope.filterSelected.employee.id;
         };
         
         /*if($scope.filterSelected.requestType.length > 1){
             var count = 0;
             
             while (count < $scope.filterSelected.requestType.length)
             {
             $scope.filterSelected.requestTypeIds     
             }
         }*/
        
        
        //if there is an id it was made through the dropdown so convert it to an array
        if($scope.filterSelected.requestType.id != null){
            $scope.filterSelected.requestType = [$scope.filterSelected.requestType.id];
        }
        
        $scope.filterSelected.fromDate.setHours(00);
        $scope.filterSelected.fromDate.setMinutes(00);
        $scope.filterSelected.toDate.setHours(23);
        $scope.filterSelected.toDate.setMinutes(59);
        $scope.complete = $scope.showComplete;
        $scope.filterBean = {
            fromDate: $scope.filterSelected.fromDate,
            toDate: $scope.filterSelected.toDate,
            driverId: $scope.driverId,
            requestTypeId: $scope.filterSelected.requestType,
            showComplete: $scope.checkboxes.showComplete,
            useDate: $scope.checkboxes.showDateFilter,
            completeOnly: $scope.filterSelected.completeOnly
        };

        console.log("Filter BEan");
        console.log($scope.filterBean);

        DiaryService.requestSearch($scope.filterBean).then(function (requests) {
            
            DiaryService.getLastAction(requests.data).then(function (newRequests){
                $scope.requests = newRequests; 
                console.log("this is the assigned tag");
                   console.log($scope.filterSelected.assigned);
               if ($scope.configuration.clientconfig ==  ClientConfigDefinitions.get().GKHIRE)  {
                   
                   if ($scope.filterBean.requestTypeId[0] != 0){
                        $scope.newRequests = DiaryFactory.removeRowsWithDrivers($scope.requests);              
                        $scope.requests = $scope.newRequests;
                   }
                   
                   else if ($scope.filterSelected.assigned == true){
                       console.log("assigned is true");
                       $scope.newRequests = DiaryFactory.removeRowsWithoutDrivers($scope.requests);              
                       $scope.requests = $scope.newRequests;
                   }
                   
                   
               }
               
             
            console.log("the request is");
            console.log($scope.configuration);
            
            $scope.requestGridOptions.data = $scope.requests;
            if($scope.filterSelected.requestType.id != null){
            $scope.currentRequestType = $scope.filterSelected.requestType;
        }
            
            $scope.loadingRequestSpinner = "";
            $scope.loadingRequestSpinner1 = "";
            $scope.loadingRequestSpinner2 = "";
            $scope.loadingRequestSpinner3 = "";
            $scope.loadingRequestSpinner4 = "";
            $scope.loadingRequestSpinner5 = "";
            $scope.loadingRequestSpinner6 = "";
            $scope.loadingRequestSpinner7 = "";
            $scope.loadingRequestSpinner8 = "";


            angular.forEach($scope.requests, function (each) {
                console.log("each");
                console.log(each);

                console.log(each.id);

                if ($scope.selectedRequest != null) {
                    console.log($scope.selectedRequest.requestId);

                    if (each.requestId === $scope.selectedRequest.requestId) {
                        console.log("Refreshing tasks");
                        $scope.selectedRequest = angular.copy(each);
                        $scope.taskGridOptions.data = $scope.selectedRequest.actions;

                    }
                }
            });
            
            });
            
            

            getPromise.resolve($scope.requests);
        });
            return getPromise.promise;
    };
    
    $scope.handleLoad = function (type){
        $scope.filterSelected.completeOnly = false;
        
        console.log(type);
        
        switch(type){
            case 1:
                $scope.filterSelected.requestType = [1000, 1004];
                $scope.filterSelected.assigned = false;
                $scope.loadingRequestSpinner1 = "glyphicon glyphicon-refresh spinning";
                $scope.currentRequestType.description = "Delivery/Change Over";
                $scope.buttonBackground = ClientConfig.requestStyle( RequestTypeDefinitions.get().DELIVERY.id );
                break;
            case 2:
                $scope.filterSelected.requestType = [1001];
                $scope.filterSelected.assigned = false;
                $scope.loadingRequestSpinner2 = "glyphicon glyphicon-refresh spinning";
                $scope.currentRequestType.description = "Collection";
                $scope.buttonBackground = ClientConfig.requestStyle( RequestTypeDefinitions.get().COLLECTION.id );
                break;
            case 3: 
                $scope.filterSelected.requestType = [1002];
                $scope.filterSelected.assigned = false;
                $scope.loadingRequestSpinner3 = "glyphicon glyphicon-refresh spinning";
                $scope.currentRequestType.description = "On Hold";
                $scope.buttonBackground = ClientConfig.requestStyle( RequestTypeDefinitions.get().HOLD.id );
                break;
            case 4:
                $scope.filterSelected.requestType = [0];
                $scope.filterSelected.assigned = false;
                $scope.loadingRequestSpinner4 = "glyphicon glyphicon-refresh spinning";
                $scope.currentRequestType.description = "All";
                $scope.buttonBackground = ClientConfig.requestStyle( RequestTypeDefinitions.get().ALL.id );
                break;
            case 5:
                $scope.filterSelected.requestType = [1003];
                $scope.filterSelected.assigned = false;
                $scope.loadingRequestSpinner5 = "glyphicon glyphicon-refresh spinning";
                $scope.currentRequestType.description = "Repair";
                $scope.buttonBackground = ClientConfig.requestStyle( RequestTypeDefinitions.get().REPAIR.id );
                break;
                
             case 6:
                $scope.filterSelected.requestType = [0];
                $scope.filterSelected.assigned = true;
                $scope.loadingRequestSpinner6 = "glyphicon glyphicon-refresh spinning";
                $scope.currentRequestType.description = "Assigned";
                $scope.buttonBackground = ClientConfig.requestStyle( RequestTypeDefinitions.get().ASSIGNED.id );
                break;
                
             case 7:
                $scope.filterSelected.requestType = [1005];
                $scope.filterSelected.assigned = false;
                $scope.loadingRequestSpinner7 = "glyphicon glyphicon-refresh spinning";
                $scope.currentRequestType.description = "Other";
                $scope.buttonBackground = ClientConfig.requestStyle( RequestTypeDefinitions.get().OTHER.id );
                break;
             
             case 8:
                $scope.filterSelected.requestType = [0];
                $scope.filterSelected.assigned = false;
                $scope.filterSelected.completeOnly = true;
                $scope.loadingRequestSpinner8 = "glyphicon glyphicon-refresh spinning";
                $scope.currentRequestType.description = "Completed";
                $scope.buttonBackground = ClientConfig.requestStyle( RequestTypeDefinitions.get().COMPLETE.id );
                
                break;
        }
        console.log($scope.filterSelected.requestType);
        $scope.load();
        
        
        
        
        
        
    }
    
    if ($scope.configuration.clientconfig === ClientConfigDefinitions.get().GKHIRE) {
                $scope.handleLoad(1);
            }

    var date = new Date();


    $scope.requestGridOptions = {
        enableFiltering: false,
        onRegisterApi: function(gridApi){
            $scope.gridApi = gridApi;
        },
        rowTemplate: ClientConfig.route('templates/diary/requestRowTemplate.html'),
        columnDefs: ClientConfig.requestGridOptions()
    };

    $scope.toggleFiltering = function(){
        $scope.requestGridOptions.enableFiltering = !$scope.requestGridOptions.enableFiltering;
        $scope.gridApi.core.notifyDataChange( uiGridConstants.dataChange.COLUMN );
    };

    $scope.isRequestSelected = function (rowEntity) {
        if ($scope.contextMenuEntity == null)
            return false;
        return $scope.contextMenuEntity.requestId === rowEntity.requestId;
    };

    $scope.isActionSelected = function (rowEntity) {
        if ($scope.contextMenuEntityAction == null)
            return false;
        return $scope.contextMenuEntityAction.id === rowEntity.id;
    };

    $scope.getActionStatusColor = function (rowEntity) {
        var color = '';
        if (rowEntity.dateCompleted !== null) {
            if (rowEntity.success) {
                color = 'actionsuccess';
            } else {
                $log.info("setting to red");
                color = 'actionfailed';
            }
            ;
        }
        ;
        if ($scope.isActionSelected(rowEntity)) {
            color = 'rowselected';
        }
        return color;
    };

    $scope.newAction = function (action) {
        if ($scope.selectedRequest != null) {
            $scope.selectedAction = action;
            var modalInstance = $uibModal.open({
                animation: $scope.animationsEnabled,
                templateUrl: ClientConfig.route('templates/modals/newActionModal.html'),
                controller: 'newActionModalCtrl',
                size: 'lg',
                scope: $scope
            });
        }
    };
    
    
    $scope.AssignDriverAction = function (action) {
        if ($scope.selectedRequest != null) {
            $scope.selectedAction = action;
            var modalInstance = $uibModal.open({
                animation: $scope.animationsEnabled,
                templateUrl: ClientConfig.route('templates/modals/assignDriverModal.html'),
                controller: 'newActionModalCtrl',
                size: 'lg',
                scope: $scope
            });
        }
    };
    
    
    $scope.failAction = function (action) {
        if ($scope.selectedRequest != null) {
            $scope.selectedAction = action;
            var modalInstance = $uibModal.open({
                animation: $scope.animationsEnabled,
                templateUrl: ClientConfig.route('templates/modals/failActionModal.html'),
                controller: 'failActionModalCtrl',
                size: 'md',
                scope: $scope
            });
        }
    };



    $scope.taskGridOptions = {
        rowTemplate: ClientConfig.route('templates/diary/actionRowTemplate.html'),
        columnDefs: ClientConfig.taskGridOptions()
    };

    console.log($scope.requestGridOptions.data);

    //$scope.gridOptions = $scope.myTestTasks;
    //$scope.myTasks = $scope.myTestTasks;
    $scope.myData = $scope.myTestData;
    $scope.filterText;
    $scope.filterGrid = {};
    $scope.filterGrid.data = $scope.myData;

    $scope.refreshData = function () {
        console.log($scope.filterGrid1);
        $scope.filterGrid.data = $filter('filter')($scope.myData, $scope.filterText, undefined);
    };

    $scope.getTasks = function (row) {
        $scope.selectedRequest = row.row.entity;
        $scope.taskGridOptions.data = $scope.selectedRequest.actions;
    };

    $scope.onRowHover = function (row) {
        //console.log(row);
        //$scope.description = row.row.entity.Description;
        // console.log($scope.element);
        //$scope.description = $scope.element.entity.Description;
        // console.log($scope.description);
        //};
    };

    $scope.menuOption = [
        ['Buy', function ($itemScope) {
                $scope.player.gold -= $itemScope.item.cost;
            }]
                //null,
                ['Sell', function ($itemScope) {
                    $scope.player.gold += $itemScope.item.cost;
                }]
    ];
    // todo 
    $scope.logout = function () {
        Configuration.clearLoginConfiguration();
        $state.go('login');
    };


    //Bootsrap Modal Controller
    $scope.items = ['item1', 'item2', 'item3'];

    $scope.animationsEnabled = true;

    $scope.selectedRequestEntity = function (rowEntity) {
        $log.info(rowEntity);
        $scope.contextMenuEntity = rowEntity;
    };

    $scope.selectedActionEntity = function (rowEntity) {
        $scope.contextMenuEntityAction = rowEntity;
    };
    
    $scope.openRunSchedule = function () {
        console.log("opening shedule")
        
        //$scope.data = data;
        //console.log("this is the data");
        //console.log(data);
        var modalInstance = $uibModal.open({
            animation: $scope.animationsEnabled,
            templateUrl: ClientConfig.route('templates/modals/runScheduleModal.html'),
            controller: 'RunScheduleCtrl',
            size: 'lg',
            windowClass: 'schedule-modal-window',
            scope: $scope,
            /*resolve: {
                details: function () {
                    if ($scope.data.company != null) {
                        $scope.details = $scope.data;
                        // console.log($scope.details);
                    } else
                    {
                        $scope.details = {};
                        //$scope.details.requestType = $scope.data;
                        //console.log("the new data is");
                        //console.log($scope.details);
                    }


                    return $scope.details;
                },
//                contacts: function () {
//                    $scope.contacts = $scope.businessEntities;
//                    console.log( "In the open modal logic contacts are");
//                    console.log($scope.contacts);
//                    return $scope.contacts;
//                },
                header: function () {
                    $scope.header = header;
                    if ($scope.header != true) {
                        $scope.header = "Edit Information";
                    } else
                    {
                        $scope.header = "New Request";
                    }
                    return $scope.header;
                },
                diaries: function () {
                    return $scope.myData;
                }
            }*/
        });

        modalInstance.result.then(function (selectedItem) {
            $scope.selected = selectedItem;

            $log.info("$scope.selected");
            $log.info($scope.selected);
            $log.info($scope.details);

            $log.info("$scope.selected.requestData");
            $log.info($scope.selected.requestData);

            if ($scope.selected.requestData != null) {
                angular.forEach($scope.requestGridOptions.data, function (each) {
                    if (each.requestId === $scope.selected.requestData.requestId) {
                        $scope.contextMenuEntity = each;
                        $scope.selectedRequest = each;
                        $scope.taskGridOptions.data = $scope.selectedRequest.actions;
                    }
                    ;
                });
            }
            ;

            if ($scope.selected.available === false && !ActionFactory.checkActionTypeExists($scope.selectedRequest, ActionDefinitions.get().type.availabilitycheck)) {
                var availabilityCheckAction = ActionFactory.buildNewPendingAction({actionType: {id: ActionDefinitions.get().type.availabilitycheck, description: 'Check Availablity'},
                    actionPriority: {id: ActionDefinitions.get().priority.high, description: 'High'}, actorPersonId: $scope.selectedRequest.employee,
                    acteePersonId: $scope.selectedRequest.contact, createdByPersonId: $scope.selectedRequest.employee, requestId: $scope.selectedRequest.requestId, comment: $scope.selectedRequest.equipementDetails});

                $scope.newAction(availabilityCheckAction);
            }
            ;

            if ($scope.selected.createOrder) {
                // create our order ( seperate controller class and service )
                $scope.newOrder();
            }
            ;


        }, function () {
            $log.info('Modal dismissed at: ' + new Date());
        });
    };

    $scope.clearDriverSearch = function (){
        console.log("clearing");
        $scope.driverId = null;
        $scope.filterSelected.employee = undefined;
    }

    $scope.setDriver = function (){
        
        console.log("the selected request is");
        console.log($scope.selectedRequest);
        
        if($scope.selectedRequest.requestType.id === ActionDefinitions.get().type.delivery || $scope.selectedRequest.requestType.id === ActionDefinitions.get().type.changeover){
                
                console.log("I'm a delivery");
                $scope.dateToUse = ActionFactory.checkDate($scope.selectedRequest.requiredDate);
                console.log("the date is");
                console.log($scope.dateToUse);
            if (!ActionFactory.checkActionTypeExists($scope.selectedRequest, ActionDefinitions.get().type.delivery)) {

                var deliveryAction = ActionFactory.buildNewPendingAction({actionType: {id: ActionDefinitions.get().type.delivery, description: 'Delivery'},
                    actionPriority: {id: ActionDefinitions.get().priority.high, description: 'High'}, actorPersonId: $scope.selectedRequest.employee,
                    acteePersonId: $scope.selectedRequest.contact, createdByPersonId: $scope.selectedRequest.employee, requestId: $scope.selectedRequest.requestId,
                    comment: $scope.selectedRequest.equipementDetails, scheduledDate: $scope.dateToUse});

                $scope.AssignDriverAction(deliveryAction);
            }
            else{
                alert("A Driver has already been assigned or A Delivery action has been completed")
            }
            ;
            
        };
        
        if($scope.selectedRequest.requestType.id === ActionDefinitions.get().type.collection){
            
            $scope.dateToUse = ActionFactory.checkDate($scope.selectedRequest.requiredDate);
            
            if (!ActionFactory.checkActionTypeExists($scope.selectedRequest, ActionDefinitions.get().type.collection)) {

                var deliveryAction = ActionFactory.buildNewPendingAction({actionType: {id: ActionDefinitions.get().type.collection, description: 'Collection'},
                    actionPriority: {id: ActionDefinitions.get().priority.high, description: 'High'}, actorPersonId: $scope.selectedRequest.employee,
                    acteePersonId: $scope.selectedRequest.contact, createdByPersonId: $scope.selectedRequest.employee, requestId: $scope.selectedRequest.requestId,
                    comment: $scope.selectedRequest.equipementDetails, scheduledDate: $scope.dateToUse});

                $scope.AssignDriverAction(deliveryAction);
            }
             else{
                alert("A Driver has already been assigned or A collection action has been completed")
            }
            ;
            
        };
        
    
        }

    $scope.open = function (data, header) {
        $scope.data = data;
        console.log("this is the data");
        console.log(data);
        var modalInstance = $uibModal.open({
            animation: $scope.animationsEnabled,
            templateUrl: ClientConfig.route('templates/modals/newEditModal.html'),
            controller: 'ModalInstanceCtrl',
            //size: 'lg',
            windowClass: 'request-modal-window',
            scope: $scope,
            resolve: {
                details: function () {
                    if ($scope.data.company != null) {
                        $scope.details = $scope.data;
                        // console.log($scope.details);
                    } else
                    {
                        $scope.details = {};
                        //$scope.details.requestType = $scope.data;
                        //console.log("the new data is");
                        //console.log($scope.details);
                    }


                    return $scope.details;
                },
//                contacts: function () {
//                    $scope.contacts = $scope.businessEntities;
//                    console.log( "In the open modal logic contacts are");
//                    console.log($scope.contacts);
//                    return $scope.contacts;
//                },
                header: function () {
                    $scope.header = header;
                    if ($scope.header != true) {
                        $scope.header = "Edit Information";
                    } else
                    {
                        $scope.header = "New Request";
                    }
                    return $scope.header;
                },
                diaries: function () {
                    return $scope.myData;
                }
            }
        });

        modalInstance.result.then(function (selectedItem) {
            $scope.selected = selectedItem;

            $log.info("$scope.selected");
            $log.info($scope.selected);
            $log.info($scope.details);
            console.log("$scope.requestGridOptions.data");
            console.log($scope.requestGridOptions.data);
            

            $log.info("$scope.selected.requestData");
            $log.info($scope.selected.requestData);
            
            $scope.load().then(function(){
                $scope.requestGridOptions.data = $scope.requests;
            
                if ($scope.selected.requestData != null) {
                    angular.forEach($scope.requestGridOptions.data, function (each) {
                        if (each.requestId === $scope.selected.requestData.requestId) {
                            $scope.contextMenuEntity = each;
                            $scope.selectedRequest = each;
                            $scope.taskGridOptions.data = $scope.selectedRequest.actions;
                        }
                        ;
                    });
                };
            });
            

            if ($scope.selected.available === false && !ActionFactory.checkActionTypeExists($scope.selectedRequest, ActionDefinitions.get().type.availabilitycheck) && $scope.configuration.clientconfig !=  ClientConfigDefinitions.get().GKHIRE) {
                var availabilityCheckAction = ActionFactory.buildNewPendingAction({actionType: {id: ActionDefinitions.get().type.availabilitycheck, description: 'Check Availablity'},
                    actionPriority: {id: ActionDefinitions.get().priority.high, description: 'High'}, actorPersonId: $scope.selectedRequest.employee,
                    acteePersonId: $scope.selectedRequest.contact, createdByPersonId: $scope.selectedRequest.employee, requestId: $scope.selectedRequest.requestId, comment: $scope.selectedRequest.equipementDetails});

                $scope.newAction(availabilityCheckAction);
            }
            ;

            if ($scope.selected.createOrder) {
                // create our order ( seperate controller class and service )
                $scope.newOrder();
            }
            ;

            
            
        }, function () {
            $log.info('Modal dismissed at: ' + new Date());
        });
    };

    
    $scope.newOrder = function() {
        
    }
    
    $scope.editDocument = function () {
        if ($scope.selectedRequest != null) {
            var documentInstance = $uibModal.open({
                animation: $scope.animationsEnabled,
                templateUrl: ClientConfig.route('templates/document/documentEditorModal.html'),
                controller: 'DocumentEditorModalCtrl',
                windowClass: 'request-modal-window',
                scope: $scope
            });

            documentInstance.result.then(function (selectedItem) {

            });
        }
    };

    $scope.deleteAction = function (action) {
        console.log(action);

    }

    $scope.rightClick = function (data) {
        console.log("right clicked on");
        console.log(data.row.entity);

    };

    $scope.toggleAnimation = function () {
        $scope.animationsEnabled = !$scope.animationsEnabled;
    };


    $scope.today = function () {
        $scope.dt = new Date();
    };
    $scope.today();

    $scope.clear = function () {
        $scope.dt = null;
    };

    $scope.inlineOptions = {
        //customClass: getDayClass,
        minDate: new Date(),
        showWeeks: true
    };

    $scope.dateOptions = {
        // dateDisabled: disabled,
        formatYear: 'yy',
        maxDate: new Date(2020, 5, 22),
        minDate: new Date(),
        startingDay: 1
    };

    // Disable weekend selection
    function disabled(data) {
        var date = data.date,
                mode = data.mode;
        return mode === 'day' && (date.getDay() === 0 || date.getDay() === 5);
    }

    $scope.toggleMin = function () {
        $scope.inlineOptions.minDate = $scope.inlineOptions.minDate ? null : new Date();
        $scope.dateOptions.minDate = $scope.inlineOptions.minDate;
    };

    $scope.toggleMin();

    $scope.open1 = function () {
        $scope.popup1.opened = true;
    };

    $scope.open2 = function () {
        $scope.popup2.opened = true;
    };

    $scope.setDate = function (year, month, day) {
        $scope.dt = new Date(year, month, day);
    };

    $scope.formats = ['dd-MMMM-yyyy', 'yyyy/MM/dd', 'dd.MM.yyyy', 'shortDate'];
    $scope.format = $scope.formats[0];
    $scope.altInputFormats = ['M!/d!/yyyy'];


    //From date popup
    $scope.popup1 = {
        opened: false
    };

    //To Date popup
    $scope.popup2 = {
        opened: false
    };


    //Deleting 
    $scope.remove = function (item, action) {
        console.log("I've been clicked");
        console.log(item);
        $scope.data = item;
        $scope.actionBool = action
        var modalInstance = $uibModal.open({
            animation: $scope.animationsEnabled,
            templateUrl: ClientConfig.route('templates/modals/deleteModal.html'),
            controller: 'DeleteModalCtrl',
            size: 'sm',
            scope: $scope
        });

        modalInstance.result.then(function (selectedItem) {
            $scope.selected = selectedItem;
            //console.log($scope.selected);
            //console.log($scope.details);
            $scope.load();

        }, function () {
            $log.info('Modal dismissed at: ' + new Date());
        });
    };

    $scope.requestStatusChange = function (item, requestStatus) {
        console.log(item);

        var modalOptions = {
            closeButtonText: 'Cancel',
            actionButtonText: 'Ok',
            headerText: 'Mark Request ' + requestStatus.description + ' ?',
            bodyText: 'Are you sure you want to change the status of this request to  ' + requestStatus.description + '?'
        };

        ConfirmModalService.showModal({}, modalOptions)
                .then(function (result) {
                    // your-custom-logic
                    if (result) {
                        var requestStatusChangeAction = ActionFactory.buildNewCompletedAction({actionType: {id: requestStatus.actionId},
                            actionPriority: {id: ActionDefinitions.get().priority.high}, actorPersonId: item.employee,
                            acteePersonId: item.contact, createdByPersonId: item.employee, requestId: item.requestId, comment: "Request Status Change"});
                        DiaryService.createAction(requestStatusChangeAction).then(function (data) {
                            $scope.load();
                            console.log("$scope.selectedRequest = ");
                            console.log($scope.selectedRequest);



                        });
                    }
                });

    };



    $scope.newDiary = function (item) {
        console.log("this is the request");
        console.log(item);


        $scope.open(item, item);

    };

    $scope.viewRunScheduleReport = function (list) {
        if (list == null){
            $scope.requestData = $scope.requestGridOptions.data;
        }
        else
        {
          $scope.requestData = list;  
        }
        RunScheduleReportService.runScheduleReport({beans: $scope.requestData}).then(function (data) {
            $log.info(data.data);
            ViewReportService.viewReport(data.data);
        });

    };


});




diaryControllers.controller('ModalInstanceCtrl', function ($q, $scope,ClientConfigDefinitions, $log, $uibModalInstance, details, header,
        DiaryService, diaries, bsLoadingOverlayService, $filter, focus, $uibModal, ActionFactory, ActionDefinitions, ClientConfig) {
    var emailCategory = 1;
    var mainLineCategory = 2;
    var mobileCategory = 3;
    var faxCategory = 4;

    $scope.header = header;
    $scope.selected = {};
    //$scope.contacts = [];
    $scope.selectedCustomer = details.company;
    if ($scope.selectedCustomer != null) {
        $scope.selectedCustomerAddress = $scope.selectedCustomer.address;
    }

    /*$scope.setANewSite = function () {
     $scope.selected.Site = {id: 0, name: 'A New Site', address: '', lat: 0, lng: 0, postcode: null, active: true, businessEntityId: 0};
     };*/

    $scope.setANewContact = function () {
        $scope.selected.Contact = undefined;
        $scope.setContactDetails();
        focus('ANewContact');
    };

    $scope.selected.Site = details.address;
    if (details.address === undefined) {
        //$scope.setANewSite();
    } else {
        //$scope.selected.Site.name = $filter('split')(details.address.address, '\n', 0);
    }
    console.log("the selected site is");
    console.log(details);
    if ($scope.selected.Site != null) {
        $scope.selectedSiteAddress = $scope.selected.Site.address;
    }
    //$scope.contacts = contacts;
    $scope.selected.Contact = details.contact;
    $scope.detailData = {};




    $scope.setContactDetails = function () {
        console.log("the contact is");
        console.log($scope.selected.Contact)
        
        
        if ($scope.selected.Contact != null && $scope.selected.Contact.contactDetails != null) {
            for (var i = 0; i < $scope.selected.Contact.contactDetails.length; i++)
            {
                console.log("the selectedContact details are");
                console.log($scope.selected.Contact.contactDetails[i]);
                if ($scope.selected.Contact.contactDetails[i].contactDetailCategoryId.id == emailCategory)
                {
                    $scope.detailData.email = $scope.selected.Contact.contactDetails[i];
                } else if ($scope.selected.Contact.contactDetails[i].contactDetailCategoryId.id == mainLineCategory)
                {
                    $scope.detailData.phone = $scope.selected.Contact.contactDetails[i];
                } else if ($scope.selected.Contact.contactDetails[i].contactDetailCategoryId.id == mobileCategory) {
                    $scope.detailData.mobile = $scope.selected.Contact.contactDetails[i];
                } else if ($scope.selected.Contact.contactDetails[i].contactDetailCategoryId.id == faxCategory) {
                    $scope.detailData.fax = $scope.selected.Contact.contactDetails[i];
                }
            }
        } else {
            $scope.detailData.email = "";
            $scope.detailData.phone = "";
            $scope.detailData.mobile = "";
            $scope.detailData.fax = "";
        }
    };
    if ($scope.selected.Contact != null) {
        $scope.setContactDetails();
    }


    $scope.loading = true;





    bsLoadingOverlayService.start();

    var initialize = function () {
        $scope.selectedPerson = undefined;

        $scope.diaries = diaries;
        console.log("the details are");
        console.log(details);
        if (details.company != undefined || details.company != null) {
            //Get all the seperate information to stop binding if the user 
            //changes something but then cancels it won't affect the code

            // angular.clone does this.

            $scope.selectedDetails = details
            console.log("the selected details are");
            console.log($scope.selectedDetails);
            //$scope.selectedPriority = details.Priority;

            //We want to get the site for the selected company




            $scope.selectedCustomer = details.company;
            $scope.selectedCustomerAddress = details.company.address;
            // $scope.selectedSiteAddress = details.site.address;
            $scope.selected.Contact = details.contact;
            $scope.selected.Site = details.address;
            $scope.selectedDescription = details.equipementDetails;
            $scope.selected.Operator = details.employee;
            $scope.selectedTransportDetails = details.transportDetails;
            $scope.selectedOrderNumber = details.orderNumber;
            $scope.selectedPriceAgreed = details.priceAgreed;
            $scope.selectedTransport = details.transportDetails;

            $scope.selectedDateTime = new Date(details.requiredDate);

             

            if ($scope.selectedDateTime.getHours() >= 14) {
                $scope.selected.afternoon = true;
            } else {
                $scope.selected.afternoon = false;
            }

            //$scope.selectedDateTime = angular.fromJson(details.requiredDate);

            $scope.selectedType = details.runCategory;
            $scope.selectedRequestType = details.requestType;
            $scope.selected.available = ActionFactory.checkActionTypeSuccessful(details, ActionDefinitions.get().type.availabilitycheck); // need to work this out from actions ( ie successful Availability action )
            $scope.selected.createOrder = false;
            $scope.selected.creationDate = details.creationDate;

        } else {
            // set required time
            $scope.selected.afternoon = false;
            
          if ($scope.selectedDateTime == null) {
               $scope.selectedDateTime = new Date();              
           }
           
            if ($scope.selectedDateTime.getHours() >= 14) {
                $scope.selected.afternoon = true;
            } else {
                $scope.selected.afternoon = false;
            }
          
            $scope.details.selectedDateTime = ClientConfig.getRequiredDate($scope.selectedDateTime, $scope.selected.afternoon);

            $scope.selectedRequestType = $scope.requestTypes[0];
            $scope.selected.available = false;
            $scope.selected.createOrder = false;
            $scope.selected.creationDate = new Date();
        }
        $scope.loading = false;
        bsLoadingOverlayService.stop();

        console.log("Sites and Contacts");
        console.log($scope.sites);
        console.log($scope.contacts);
        console.log("------------------");


    };

    var allTasks = [];
    allTasks.push(DiaryService.getCustomers().then(function (customers) {
        $scope.persons = customers.data;
    }));
    ;

    allTasks.push(DiaryService.getEmployees().then(function (employees) {
        $scope.employees = employees.data;


        if ($scope.selectedCustomer == null) {
            angular.forEach($scope.employees, function (each) {
                if (each.id === parseInt(localStorage.operatorId)) {
                    $scope.selected.Operator = each;
                }
                ;
            });
        }
        ;
    }));
    allTasks.push(DiaryService.getRunCategories().then(function (runTypes) {
        $scope.types = runTypes.data;
        
        // if it's gk we're going to set it to the 4th item (normal)
         if ($scope.configuration.clientconfig ==  ClientConfigDefinitions.get().GKHIRE)  {
             $scope.setType($scope.types[3]);
         }
         else
         {
        $scope.setType($scope.types[0]);
        }
        $log.info("finished runCategories");
    }));

    if (details.company !== undefined) {
        allTasks.push(DiaryService.getSites(details.company.id).then(function (siteList) {
            $scope.sites = siteList.data;
        }));
        allTasks.push(DiaryService.getContacts(details.company.id).then(function (contactList) {
            $scope.contacts = contactList.data;
        }));
    }

    $q.all(allTasks).then(function (data) {
        initialize();
        $log.info("Finished AllTasks");
    },
            function (error) {
                initialize();
                $log.info("Finished AllTasks");
            });



    $scope.changed = function () {
        $log.info($scope.selectedDateTime);

    };
    
    
    $scope.setCustomer = function (data) {
        console.log(data);
        $scope.selectedCustomer = data;
        $scope.selectedCustomerName = data.name;
        $scope.selectedCustomerAddress = $scope.selectedCustomer.address
        DiaryService.getSites($scope.selectedCustomer.id).then(function (siteList) {
            $scope.sites = siteList.data;
            $scope.goToSite = true;
            //$scope.focus("siteAddress");
        });
        DiaryService.getContacts($scope.selectedCustomer.id).then(function (contactList) {
            $scope.contacts = contactList.data;
        });
        $scope.selected.Contact = null;

        //$scope.setANewSite(); // we will always have at least one site entry the "A New Site" 
    };

    $scope.setContact = function (data) {
        
        $scope.selected.Contact = data;
        $scope.setContactDetails();
        //$scope.focus("description");
        $scope.goToContact = false;
        console.log("going to description");
        $scope.goToDescription = true;
    };

    $scope.setSite = function (data) {
        //$scope.loseFocus("siteAddress");
        $scope.goToSite = false;
        $scope.goToContact = true;
        $scope.selected.Site = angular.copy(data);
        $scope.selectedSiteAddress = $scope.selected.Site.address;
        //document.getElementById("contact").focus();
        //$scope.setContactDetails();



    };

    $scope.loseFocus = function (data) {
        console.log("blurring the data");
        console.log(document.getElementById(data));
        document.getElementById(data).blur();
    };

    $scope.focus = function (data) {
        console.log("focusing on data");
        console.log(data);
        console.log(document.getElementById(data));
        document.getElementById(data).focus();
    }

    $scope.setPriority = function (data) {
        $scope.selectedPriority = data;
        console.log($scope.selectedPriority);
    };

    $scope.setType = function (data) {
        $scope.selectedType = data;
        console.log($scope.selectedType);

    };

    $scope.setRequestType = function (data) {
        $scope.selectedRequestType = data;
        console.log($scope.selectedRequestType);

    };

    $scope.setEmployee = function (data) {
        $scope.selected.Operator = data;
        console.log($scope.selected.Operator);
    };


    $scope.diaryDetails = details;
    $scope.selected = {
        //item: $scope.items[0]
    };

    $scope.ok = function (data) {
        console.log("the details are");
        console.log(details);
        console.log("the site is");
        console.log($scope.selected.Site);
        
        var refreshRequests = function () {
            DiaryService.requestSearch($scope.filterBean).then(function (requests) {
                $scope.requests = requests.data;
                //$scope.requestGridOptions.data = $scope.requests;
                $uibModalInstance.close($scope.details);
            });
        };

        $scope.createRequest = function () {
            console.log("creating request");
            console.log($scope.details);
            DiaryService.createRequest($scope.details).then(function (request) {
                console.log("synced");
                console.log(request);

                $scope.details.requestData = request.data;


                if ($scope.selected.available && !ActionFactory.checkActionTypeExists(request.data, ActionDefinitions.get().type.availablitycheck) && $scope.configuration.clientconfig !=  ClientConfigDefinitions.get().GKHIRE) {
                    $log.info("Creating completed AvailabilityCheck Action");
                    var availabilityCheckAction = ActionFactory.buildNewCompletedAction({actionType: {id: ActionDefinitions.get().type.availabilitycheck},
                        actionPriority: {id: ActionDefinitions.get().priority.high}, actorPersonId: request.data.employee,
                        acteePersonId: request.data.contact, createdByPersonId: request.data.employee, requestId: request.data.requestId, comment: request.data.equipementDetails});
                    DiaryService.createAction(availabilityCheckAction).then(function (data) {
                        refreshRequests();
                    });
                } else {
                    refreshRequests();
                }
                ;
            });
        };

        $scope.setDetails = function () {
            $scope.details = {
                operator: $scope.selected.Operator,
                company: $scope.selectedCustomer,
                address: $scope.selected.Site,
                contact: $scope.selected.Contact,
                equipementDetails: $scope.selectedDescription,
                employee: $scope.selected.Operator,
                transportDetails: $scope.selectedTransportDetails,
                orderNumber: $scope.selectedOrderNumber,
                priceAgreed: $scope.selectedPriceAgreed,
                requiredDate: $scope.selectedDateTime,
                requestType: $scope.selectedRequestType,
                runCategory: $scope.selectedType,
                requestId: 0,
                creationDate: $scope.selected.creationDate,
                descripton: "test",
                available: $scope.selected.available,
                createOrder: $scope.selected.createOrder,
                requestData: $scope.requestData,
                requestStatus: {
                    id: 1,
                    description: "Unassigned"
                }
            }

            $scope.createRequest();
        };

        $scope.checkCustomer = function (newRequest) {
            //Checking to see if we're creating a new contact.
            console.log("this is the customer");
            console.log($scope.selectedCustomer);
            if ($scope.selectedCustomer != null) {
                if ($scope.selectedCustomer.id == null) {
                    DiaryService.buildNewBusiness($scope.selectedCustomerAddress, $scope.selectedCustomer).then(function (data) {
                        console.log("the customer bean is");
                        console.log(data);
                        $scope.selectedCustomer = data;
                        //$scope.details.contact = $scope.selected.Contact;
                        $scope.checkContact(newRequest);
                    });
                } else
                {
                    $scope.checkContact(newRequest);
                }

            }
        };

        $scope.checkContact = function (newRequest) {
            console.log("this is the contact");
            console.log($scope.selected.Contact)
            if ($scope.selected.Contact != null) {
                //if ($scope.selected.Contact.id == null) {
                DiaryService.buildContact($scope.selected.Contact, $scope.detailData).then(function (data) {
                    console.log("the contact bean is");
                    console.log(data);
                    $scope.selected.Contact = data;
                    $scope.details.contact = $scope.selected.Contact;


                    console.log("new Details addedd");
                    console.log($scope.details);
                    $scope.checkSite(newRequest);

                });
                // } else {
                //     $scope.checkSite(newRequest);
                // }

            } else {
                $scope.checkSite(newRequest);
            }
        };

        $scope.checkSite = function (newRequest) {
            if ($scope.selected.Site != null) {

                /*if ($scope.selected.Site.id == 0) {
                 $scope.selected.Site.address;
                 DiaryService.buildNewSite($scope.address).then(function (data) {
                 console.log("the site bean is");
                 console.log(data);
                 $scope.selected.Site = data;
                 $scope.details.site = $scope.selected.Site;
                 
                 
                 console.log("new Details addedd");
                 console.log($scope.details);
                 if (newRequest == true) {
                 $scope.setDetails();
                 } else {
                 $scope.createRequest();
                 }
                 
                 
                 });
                 } else*/ {
                    if (newRequest == true) {
                        $scope.setDetails();
                    } else {
                        $scope.createRequest();
                    }
                }


            } else {
                if (newRequest == true) {
                    $scope.setDetails();
                } else {
                    $scope.createRequest();
                }
            }
        };

        if (details.company == undefined || details.company == null) {
            console.log("creating new request");

            //Checking to see if we're creating a new contact.
            console.log("the customer is");

            console.log($scope.selectedCustomer);
            if ($scope.selectedCustomer != null) {
                //Beginning process to save 
                $scope.checkCustomer(true);
            }





            //$scope.diaries.push($scope.diaryDetails);
        } else {
            $scope.details = details;
            $scope.selectedCustomer.address = $scope.selectedCustomerAddress;
            console.log($scope.selectedCustomer);
            console.log($scope.selected.Site);
            console.log($scope.selectedDateTime);
            console.log($scope.selectedDescription);

            console.log($scope.details);
            $scope.details.actions = null;

            if ($scope.selectedCustomer != undefined || $scope.selectedCustomer != null) {
                $scope.details.company = $scope.selectedCustomer;
            }
            ;
            if ($scope.selected.Site != undefined || $scope.selected.Site != null) {
                // $scope.selected.Site.address = $scope.selectedSiteAddress;
                $scope.details.address = $scope.selected.Site;
            }
            ;
            //$scope.details.contact = $scope.selected.Contact;
            $scope.details.equipementDetails = $scope.selectedDescription;
            $scope.details.employee = $scope.selected.Operator;
            $scope.details.transportDetails = $scope.selectedTransportDetails;
            $scope.details.orderNumber = $scope.selectedOrderNumber;
            $scope.details.priceAgreed = $scope.selectedPriceAgreed;
            $scope.details.transportDetails = $scope.selectedTransport;
            $scope.details.requiredDate = new Date($scope.selectedDateTime);


            $scope.details.requiredDate = ClientConfig.getRequiredDate($scope.details.requiredDate, $scope.selected.afternoon);

            $scope.details.runCategory = $scope.selectedType;
            $scope.details.requestType = $scope.selectedRequestType;
            $scope.details.available = $scope.selected.available;
            $scope.details.createOrder = $scope.selected.createOrder;


            $scope.details.requestStatus = {
                id: 1,
                description: "Unassigned"
            }
            console.log("the details are");
            console.log($scope.details);

            $scope.checkCustomer(false);



        }

    };

    $scope.cancel = function () {
        $uibModalInstance.dismiss('cancel');
    };
});


diaryControllers.controller('DeleteModalCtrl', function ($scope, $log, DiaryService, $uibModalInstance) {
    $scope.details = $scope.data;
    $scope.oldrequestGridOptions = angular.copy( $scope.requestGridOptions );
    $scope.oldTaskGridOptions = $scope.taskGridOptions ;
    console.log($scope.details);
    console.log($scope.actionBool);
    if ($scope.actionBool != true) {
        $scope.message = "Do you want to delete this request?";
        $scope.item = 'request';
    } else
    {
        $scope.message = "Do you want to delete this action?"
        $scope.item = 'action';
    }

    $scope.ok = function (data) {
        if ($scope.actionBool != true) {
            $scope.id = $scope.details.requestId
            DiaryService.deleteRequest($scope.id).then(function (siteList) {
                console.log("deleted");
                console.log(siteList.data);
                DiaryService.requestSearch($scope.filterBean).then(function (requests) {
                    $scope.requests = requests.data;
                    $scope.oldrequestGridOptions.data = $scope.requests;

                    console.log("this is the actions");
                    console.log($scope.taskGridOptions);
                });
                $scope.oldTaskGridOptions.data = {};
            });
        } else
        {

            $scope.id = $scope.details.id;
            DiaryService.deleteAction($scope.id).then(function (siteList) {
                console.log("deleted");
                console.log(siteList.data);

                for (var i = 0; i < $scope.requests.length; i++) {

                    if ($scope.requests[i].requestId === $scope.details.requestId) {

                        $scope.oldTaskGridOptions.data = $scope.requests[i].actions;
                    }

                }

                DiaryService.requestSearch($scope.filterBean).then(function (requests) {
                    $scope.requests = requests.data;
                    $scope.oldrequestGridOptions.data = $scope.requests;
                    console.log($scope.requests);
                    console.log("this is the actions");
                    console.log($scope.taskGridOptions);

                    for (var i = 0; i < $scope.requests.length; i++) {

                        if ($scope.requests[i].requestId === $scope.details.requestId) {

                            $scope.oldTaskGridOptions.data = $scope.requests[i].actions;
                        }

                    }
                });




            });
        }
        $uibModalInstance.close($scope.details);
    };

    $scope.cancel = function () {
        $uibModalInstance.dismiss('cancel');
    };

});


diaryControllers.controller('newActionModalCtrl', function ($q, $scope, $log, DiaryService, $uibModalInstance, bsLoadingOverlayService) {
    $scope.oldrequestGridOptions = angular.copy( $scope.requestGridOptions );
    $scope.oldTaskGridOptions = angular.copy( $scope.taskGridOptions );
    $scope.request = angular.copy($scope.selectedRequest);
    $scope.oldSelectedAction = $scope.selectedAction;

    if ($scope.selectedAction != null) {
        $scope.selected = angular.copy($scope.selectedAction);
        console.log($scope.selected);
        $scope.selected.dateScheduled = new Date($scope.selected.dateScheduled);


        if ($scope.selected.dateCompleted != null) {
            $scope.selected.dateCompleted = new Date($scope.selected.dateCompleted);
        }
        ;

    } else {
        $scope.selected = {};
        $scope.selected.id = 0;
        $scope.selected.seq = 0;
        $scope.selected.actionType = {};
        $scope.selected.actorPersonId = {};
        $scope.selected.acteePersonId = $scope.request.contact;
        $scope.selected.comment = null;
        $scope.selected.createdByPersonId = {};
        $scope.selected.dateCompleted = null;
        $scope.selected.dateCreated = new Date();
        $scope.selected.dateScheduled = new Date();
        $scope.selected.requestId = $scope.selectedRequest.requestId;
    }

    $scope.completed = false;
    $log.info("$scope.selected.dateCompleted");
    $log.info($scope.selected.dateCompleted);
    if ($scope.selected.dateCompleted != null) {
        $scope.completed = true;
    }
    ;

    $scope.loading = true;
    bsLoadingOverlayService.start();
    var promiseTasks = [];
    promiseTasks.push(DiaryService.getPriorities().then(function (priorities) {
        $scope.states = priorities.data;
        if ($scope.selected.actionPriority == null) {
            $scope.selected.actionPriority = $scope.states[0];
        }
    }));
    promiseTasks.push(DiaryService.getActionTypes().then(function (types) {
        console.log("the actions are");
        $scope.types = types.data;

        $log.info("$scope.selected.actionType.id");
        $log.info($scope.selected.actionType.id);

        if ($scope.selected.actionType.id === undefined) {
            $scope.selected.actionType = $scope.types[0];
        }
        ;
    }));
    promiseTasks.push(DiaryService.getEmployees().then(function (employees) {
        $scope.employees = employees.data;

        if ($scope.selected.id === 0) {
            angular.forEach($scope.employees, function (each) {
                $log.info("each.id === localStorage.operatorId ");
                $log.info(each.id);
                $log.info(localStorage.operatorId);

                if (each.id === parseInt(localStorage.operatorId)) {
                    $scope.selected.createdByPersonId = each;
                }
                ;
            });
        }
        ;
    }));

    if ($scope.selectedRequest.company !== undefined) {
        promiseTasks.push(DiaryService.getContacts($scope.selectedRequest.company.id).then(function (contactList) {
            $scope.contacts = contactList.data;

        }));
    }
    ;

    $q.all(promiseTasks).then(function (data) {
        bsLoadingOverlayService.stop();
        $scope.loading = false;
    },
            function (failed) {
                bsLoadingOverlayService.stop();
                $scope.loading = false;
            });


    $scope.actionDatePopup = {
        opened: false
    };

    $scope.actionDateOpen = function () {

        $scope.actionDatePopup.opened = true;

    };

    $scope.actionCompletedDatePopup = {
        opened: false
    };

    $scope.actionCompletedDateOpen = function () {

        $scope.actionCompletedDatePopup.opened = true;

    };

    $scope.setAction = function (action) {
        $scope.selectedAction = action;
    };

    $scope.setPriority = function (priority) {
        $scope.selected.actionPriority = priority;
    };

    // how much the hours and mins increment
    $scope.hstep = 1;
    $scope.mstep = 1;

    $scope.toggleCompleted = function () {
        $log.info("toggled");
        if ($scope.completed === true) {
            $log.info("true")
            $scope.selected.dateCompleted = new Date();
            $scope.selected.success = true;
        } else {
            $log.info("False");
            $scope.selected.dateCompleted = null;
            $scope.selected.success = false;
        }
        $log.info("Completed Date");
        $log.info($scope.selected.dateCompleted)
    };

    $scope.actionOk = function (data) {



        console.log("the actions are");
        console.log($scope.taskGridOptions.data);

        DiaryService.createAction($scope.selected).then(function (data) {
            console.log("synced");
            console.log(data.data);
            $scope.oldSelectedAction = $scope.selected;
            if ($scope.oldSelectedAction.id == 0) {
                $scope.oldTaskGridOptions.data.push($scope.oldSelectedAction);
            } else
            {
                console.log("in the else beginning loop");
                for (var i = 0; i < $scope.oldTaskGridOptions.data.length; i++)
                {
                    console.log("the action ids are");
                    console.log($scope.oldTaskGridOptions.data[i].id + "-" + $scope.oldSelectedAction.id)
                    if ($scope.oldTaskGridOptions.data[i].id === $scope.oldSelectedAction.id)
                    {
                        $scope.oldTaskGridOptions.data[i] = $scope.oldSelectedAction;
                    }
                }
            }


            DiaryService.requestSearch($scope.filterBean).then(function (requests) {
            //$scope.load().then(function (requests){ 
                console.log("these are the requests")
                console.log(requests);
            $scope.requests = requests.data;
                $scope.oldrequestGridOptions.data = $scope.requests;

                console.log("this is the actions");
                console.log($scope.taskGridOptions);

                for (var i = 0; i < $scope.requests.length; i++) {
                    console.log("the ids are");
                    console.log($scope.requests[i].requestId + "-" + $scope.oldSelectedAction.requestId);
                    if ($scope.requests[i].requestId === $scope.oldSelectedAction.requestId) {
                        console.log("in fors if getting new actions");
                        $scope.oldTaskGridOptions.data = $scope.requests[i].actions;
                    }

                }
                console.log("going to load now");
                console.log($scope.filterBean);
                $scope.load();
            });
        });
        $uibModalInstance.close($scope.details);
    };

    $scope.cancel = function () {
        $uibModalInstance.dismiss('cancel');
    };

});

diaryControllers.directive('focusMe', function($timeout, $parse) {
      return {
          //scope: true,   // optionally create a child scope
          link: function(scope, element, attrs) {
              var model = $parse(attrs.focusMe);
              scope.$watch(model, function(value) {
                  if(value === true) { 
                      $timeout(function() {
                          element[0].focus();
                      });
                  }
              });
          }
      };
    })
