diaryServices.factory('DiaryConfigService',function($q,$http,Configuration,$log){
    
    
    var getCustomers = function(){
       var getPromise = $q.defer();
       // var credentials = { username: user, password: pass };
        $log.info("pre get");
            $http.get( Configuration.getConfiguration().customerListUrl).then(function(data){
            $log.info( data );
            getPromise.resolve( data ); // return token
        },
        function(error){
            //$log.error( error );
            getPromise.resolve( "" ); // on error return empty token
        });
        
        return getPromise.promise;
    };
    
    
    var getSites= function(cust){
       var getPromise = $q.defer();
       // var credentials = { username: user, password: pass };
        $log.info("pre get");
            $http.get( Configuration.getConfiguration().siteListUrl + cust).then(function(data){
            $log.info( data );
            getPromise.resolve( data ); // return token
        },
        function(error){
            //$log.error( error );
            getPromise.resolve( "" ); // on error return empty token
        });
        
        return getPromise.promise;
    };
    
    var getActionTypes= function(cust){
       var getPromise = $q.defer();
       // var credentials = { username: user, password: pass };
        $log.info("pre get");
            $http.get( Configuration.getConfiguration().actionTypeListUrl).then(function(data){
            $log.info( data );
            getPromise.resolve( data ); // return token
        },
        function(error){
            //$log.error( error );
            getPromise.resolve( "" ); // on error return empty token
        });
        
        return getPromise.promise;
    };
    
    var getPriorities= function(cust){
       var getPromise = $q.defer();
       // var credentials = { username: user, password: pass };
        $log.info("pre get");
            $http.get( Configuration.getConfiguration().priorityListUrl).then(function(data){
            $log.info( data );
            getPromise.resolve( data ); // return token
        },
        function(error){
            //$log.error( error );
            getPromise.resolve( "" ); // on error return empty token
        });
        
        return getPromise.promise;
    };
    
    return{
        getCustomers: getCustomers,
        getSites: getSites,
        getPriorities: getPriorities,
        getActionTypes: getActionTypes
        
    };
});


